﻿Imports System.Runtime.CompilerServices
Imports System.Drawing
Imports System.Runtime.InteropServices

Namespace System.Windows.Forms

   Public Module PaddingX

      ''' <summary> returns a with Paddings amount enlarged Rectangle </summary>
      <Extension()> _
      Public Function Add(ByVal Subj As Rectangle, ByVal pd As Padding) As Rectangle
         With Subj
            Return New Rectangle(.X - pd.Left, .Y - pd.Top, .Width + pd.Horizontal, .Height + pd.Vertical)
         End With
      End Function
      ''' <summary> returns a with Paddings amount shrinked Rectangle </summary>
      <Extension()> _
      Public Function Subtract(ByVal Subj As Rectangle, ByVal pd As Padding) As Rectangle
         With Subj
            Return New Rectangle(.X + pd.Left, .Y + pd.Top, .Width - pd.Horizontal, .Height - pd.Vertical)
         End With
      End Function
      <Extension()> _
      Public Function ToRect(ByVal subj As Padding) As Rect
         With subj
            Return New Rect(.Left, .Top, .Right, .Bottom)
         End With
      End Function
      <Extension()> _
      Public Function NearVector(ByVal subj As Windows.Forms.Padding) As Vector
         Return New Vector(subj.Left, subj.Top)
      End Function
      <Extension()> _
      Public Function FarVector(ByVal subj As Windows.Forms.Padding) As Vector
         Return New Vector(subj.Right, subj.Bottom)
      End Function
   End Module

End Namespace
